scala.tools.nsc.typechecker.MethodSynthesis.MethodSynth

# Derived

#### sealed trait Derived extends AnyRef

This trait assembles what's needed for synthesizing derived methods. Important: Typically, instances of this trait are created TWICE for each derived symbol; once form Namers in an enter method, and once from Typers in addDerivedTrees. So it's important that creating an instance of Derived does not have a side effect, or if it has a side effect, control that it is done only once.

Source
  MethodSynthesis.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
AnyBeanGetter, BaseGetter, BeanAccessor, BeanGetter, BeanSetter, BooleanBeanGetter, DerivedFromClassDef, DerivedFromMemberDef, DerivedFromValDef, DerivedGetter, DerivedSetter, Field, Getter, ImplicitClassWrapper, LazyValGetter, NoSymbolBeanGetter, Param, Setter
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Derived
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def completer(sym: Global.Symbol): Global.Type

   type completer for the synthetic member.

2. #### abstract def derivedSym: Global.Symbol

   The derived symbol.

   The derived symbol. It is assumed that this symbol already exists and has been entered in the parent scope when derivedSym is called

3. #### abstract def derivedTree: Global.Tree

   The definition tree of the derived symbol.

4. #### abstract def flagsExtra: Long

   The flags that the derived symbol has in addition to those retained from the original symbol

5. #### abstract def flagsMask: Long

   The flags that are retained from the original symbol

6. #### abstract def name: Global.TermName

   The name of the method

7. #### abstract def tree: Global.Tree

   The tree from which we are deriving a synthetic member.

   The tree from which we are deriving a synthetic member. Typically, that's given as an argument of the instance.

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Namers.Namer.Derived to any2stringadd[Namers.Namer.Derived] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Namers.Namer.Derived, B)

   Implicit information
     This member is added by an implicit conversion from Namers.Namer.Derived to ArrowAssoc[Namers.Namer.Derived] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

8. #### def ensuring(cond: (Namers.Namer.Derived) ⇒ Boolean, msg: ⇒ Any): Namers.Namer.Derived

   Implicit information
     This member is added by an implicit conversion from Namers.Namer.Derived to Ensuring[Namers.Namer.Derived] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

9. #### def ensuring(cond: (Namers.Namer.Derived) ⇒ Boolean): Namers.Namer.Derived

   Implicit information
     This member is added by an implicit conversion from Namers.Namer.Derived to Ensuring[Namers.Namer.Derived] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: Boolean, msg: ⇒ Any): Namers.Namer.Derived

    Implicit information
      This member is added by an implicit conversion from Namers.Namer.Derived to Ensuring[Namers.Namer.Derived] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean): Namers.Namer.Derived

    Implicit information
      This member is added by an implicit conversion from Namers.Namer.Derived to Ensuring[Namers.Namer.Derived] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

13. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

14. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

15. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Namers.Namer.Derived to StringFormat[Namers.Namer.Derived] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

16. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

17. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

18. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

19. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

20. #### final def notify(): Unit

    Definition Classes
      AnyRef

21. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

22. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

23. #### def toString(): String

    Definition Classes
      AnyRef → Any

24. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

25. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

26. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

27. #### def →[B](y: B): (Namers.Namer.Derived, B)

    Implicit information
      This member is added by an implicit conversion from Namers.Namer.Derived to ArrowAssoc[Namers.Namer.Derived] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Namers.Namer.Derived to any2stringadd[Namers.Namer.Derived]

### Inherited by implicit conversion StringFormat from Namers.Namer.Derived to StringFormat[Namers.Namer.Derived]

### Inherited by implicit conversion Ensuring from Namers.Namer.Derived to Ensuring[Namers.Namer.Derived]

### Inherited by implicit conversion ArrowAssoc from Namers.Namer.Derived to ArrowAssoc[Namers.Namer.Derived]

### Ungrouped